import java.awt.*;

public class Camera {
	double w,h;
	Zlist zlist;
	//============================================
	//constructor
	//============================================
	public Camera(int width, int height) {
		this.w = (double) width;
		this.h = (double) height;
		this.zlist = new Zlist(1024);
	}
	//============================================
	//scan polygon from a modellist and get zlist of 2d polygons
	//============================================
	public void scan(ModelList zone) {
		this.zlist.reset();
		for (int j = 0; j < zone.num; j++) {
			zone.list[j].absolute();
			double tmp = zone.list[j].center.dist();	//backface culling
			for (int i = 0 ; i < zone.list[j].polygons.num; i++) {
				Poly2d p = new Poly2d( zone.list[j].polygons.list[i] , zone.list[j].points, this.w, this.h);
				if ((p.z <= tmp || zone.list[j].polygons.list[j].backface_culling == false) && p.avoid == false) {
					this.zlist.append(p);
				}
			}
			zone.list[j].relative();
		}
		this.zlist.sort();
	}
	//============================================
	//draw all polygons from a zlist
	//============================================
	public void draw(Graphics g) {
		for (int i = 0; i < this.zlist.num; i++){
			g.setColor(this.zlist.list[i].fill);	//interior color of the polygon
			g.fillPolygon(this.zlist.list[i].x, this.zlist.list[i].y, this.zlist.list[i].num);
			g.setColor(this.zlist.list[i].draw);	//border color of the polygon
			g.drawPolygon(this.zlist.list[i].x, this.zlist.list[i].y, this.zlist.list[i].num);
		}
	}
	//============================================
	//end
	//============================================
}
