
import java.awt.*;
import java.applet.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;

public class Main extends Applet implements Runnable, MouseListener, MouseMotionListener{
	//======================================================================================================
	//applet--------------------------
	//======================================================================================================
    	int width, height;
	Image imagebuffer;
	Graphics b;
	Thread t = null;

    	public void init() {
        	width = getSize().width; height = getSize().height;
		setBackground(Color.white);
		imagebuffer = createImage(width, height);
		b = imagebuffer.getGraphics();
		b.setColor(Color.white);
		addMouseListener( this );
		addMouseMotionListener( this );
		setFocusable(true);
		//-----
		begin();
		//-----
    }
	
	public void start(){
		if (t == null) { t = new Thread(this); t.start(); }
	}
	public void run(){
		try{
			while (true) {
				//-----
				loop();
				//-----
				repaint();
				t.sleep(40);
			}
		}
		catch (InterruptedException e) { }
	}
		
    	public void paint (Graphics g) {
		b.clearRect(0,0,width,height);
		//---------
		draw(b);
		//---------
		g.drawImage(imagebuffer,0,0,this);
	}
	public void update (Graphics g) {
		paint(g);
	}
	
	public void mouseEntered( MouseEvent e ) {}
	public void mouseExited( MouseEvent e ) {}
	public void mouseClicked( MouseEvent e ) {}
	public void mousePressed( MouseEvent e ) {
		mouse_down();
	}
	public void mouseReleased( MouseEvent e ) {
		mouse_up();
	}
	public void mouseMoved( MouseEvent e ) 	{  
		mouse( e.getX(), e.getY()); 
		e.consume();
	}
	public void mouseDragged( MouseEvent e ) { }
	//============================================
	//freespace
	//============================================

	String Pyramid = "0.5:0.5:0.5 0.0:0.0:0.0 -0.5:-0.5:-0.5 0.5:-0.5:-0.5 0.5:-0.5:0.5 -0.5:-0.5:0.5\n0.5:0.5:0.5 0.0:0.0:0.0 -0.5:-0.5:-0.5 0.5:-0.5:-0.5 0.0:0.5:0.0\n0.5:0.5:0.5 0.0:0.0:0.0 0.5:-0.5:-0.5 0.5:-0.5:0.5 0.0:0.5:0.0\n0.5:0.5:0.5 0.0:0.0:0.0 0.5:-0.5:0.5 -0.5:-0.5:0.5 0.0:0.5:0.0\n0.5:0.5:0.5 0.0:0.0:0.0 -0.5:-0.5:-0.5 -0.5:-0.5:0.5 0.0:0.5:0.0\n";
	Model pyramid ;
	ModelList zone;
	Camera camera;

	public void begin(){
		camera = new Camera(width,height);
		zone = new ModelList(10);

		Model pyramid = new Model(Pyramid);
		pyramid.move(2.0,0,4.0);
		zone.append(pyramid);

		Model pyramid2 = new Model(Pyramid);
		pyramid2.move(-2.0,0.2,4.0);
		pyramid2.rotate_z(Math.PI);
		zone.append(pyramid2);
	}

	boolean tmp1 = false, tmp2 = false, tmp3 = false;
	
	double turn,move;
	public void loop(){
		zone.absolute();
		zone.rotate_y(-turn);
		zone.relative();
		zone.move(0,0,move);
			Model m1 = zone.list[0];
			Model m2 = zone.list[1];
			m1.move(-0.01,0,0);
			if (m1.collide_with_bounding_sphere_of( m2 ) == true) {
				if (tmp1 == false) { 
					tmp1 = true; 
					System.out.println("bounding_sphere in") ;
				}
			}
			else {
				if (tmp1 == true) { 
					tmp1 = false; 
					System.out.println("bounding_sphere out") ;
				}
			}

			if (m1.planes_vs_bounding_sphere_of( m2) == true) {
				if (tmp2 == false) { 
					tmp2 = true; 
					System.out.println("plane/Bsphere in") ;
				}
			}
			else {
				if (tmp2 == true) { 
					tmp2 = false; 
					System.out.println("plane/Bsphere out") ;
				}
			}

	}
		
	public void mouse(int x, int y){
		turn = (double)(x - (width / 2))/(width*30); //double
		move = (double)(y - (height / 2))/(height*30); //double
	}
	public void mouse_down() {
	}
	public void mouse_up() {
	}
		
	public void draw(Graphics g){
		camera.scan(zone);
		camera.draw(g);
	}

}
