public class Vector {
	//==================================================================
	//operation
	//==================================================================
	//----------------------------------
	//set
	//----------------------------------
	public static void set(double[] result, double x, double y, double z) {
		result[0] = x;
		result[1] = y;
		result[2] = z;
	}
	public static void set(double[] result, double d) {
		Vector.set(result, d, d, d);
	}
	public static void set(double[] result, double[] a) {
		Vector.set(result, a[0], a[1], a[2]);
	}
	//----------------------------------
	//add
	//----------------------------------
	public static void add(double[] result, double[] a, double x, double y, double z) {
		result[0] = a[0] + x;
		result[1] = a[1] + y;
		result[2] = a[2] + z;
	}
	public static void add(double[] result, double[] a, double b) {
		Vector.add(result, a, b, b, b);
	}
	public static void add(double[] result, double[] a, double[] b) {
		Vector.add(result ,a, b[0], b[1], b[2]);
	}
	//----------------------------------
	//sub
	//----------------------------------
	public static void sub(double[] result, double[] a, double x, double y, double z) {
		result[0] = a[0] - x;
		result[1] = a[1] - y;
		result[2] = a[2] - z;
	}
	public static void sub(double[] result, double[] a, double b) {
		Vector.sub(result, a, b, b, b);
	}
	public static void sub(double[] result, double[] a, double[] b) {
		Vector.sub(result ,a, b[0], b[1], b[2]);
	}
	//----------------------------------
	//mul
	//----------------------------------
	public static void mul(double[] result, double[] a, double x, double y, double z) {
		result[0] = a[0] * x;
		result[1] = a[1] * y;
		result[2] = a[2] * z;
	}
	public static void mul(double[] result, double[] a, double b) {
		Vector.mul(result, a, b, b, b);
	}
	public static void mul(double[] result, double[] a, double[] b) {
		Vector.mul(result ,a, b[0], b[1], b[2]);
	}
	//----------------------------------
	//div
	//----------------------------------
	public static void div(double[] result, double[] a, double x, double y, double z) {
		result[0] = a[0] / x;
		result[1] = a[1] / y;
		result[2] = a[2] / z;
	}
	public static void div(double[] result, double[] a, double b) {
		Vector.div(result, a, b, b, b);
	}
	public static void div(double[] result, double[] a, double[] b) {
		Vector.div(result ,a, b[0], b[1], b[2]);
	}
	//==================================================================
	//rotation
	//==================================================================
	//----------------------------------
	//rotate around x
	//----------------------------------
	public static void rotate_x(double[] result, double[] a, double r) {
		double yy = a[1], zz = a[2], sin = Math.sin(r), cos = Math.cos(r);
		result[1] = (yy*cos)-(zz*sin);
		result[2] = (yy*sin)+(zz*cos);
	}
	//----------------------------------
	//rotate around y
	//----------------------------------
	public static void rotate_y(double[] result, double[] a, double r) {
		double xx = a[0], zz = a[2], sin = Math.sin(r), cos = Math.cos(r);
		result[0] = (zz*sin)+(xx*cos);
		result[2] = (zz*cos)-(xx*sin);
	}
	//----------------------------------
	//rotate around z
	//----------------------------------
	public static void rotate_z(double[] result, double[] a, double r) {
		double xx = a[0], yy = a[1], sin = Math.sin(r), cos = Math.cos(r);
		result[0] = ((yy*sin)+(xx*cos));
		result[1] = ((yy*cos)-(xx*sin));
	}
	//==================================================================
	//vector speciality
	//==================================================================
	//----------------------------------
	//dot product a = b * c , return single value
	//----------------------------------
	public static double dot_product(double[] a, double[] b) {
		return (a[0] * b[0]) + (a[1] * b[1]) + (a[2] * b[2]);
	}
	//----------------------------------
	//cross product a = b x c , return vector
	//----------------------------------
	public static void cross_product(double[] result, double[] a, double[] b) {
		result[0] = (a[1] * b[2]) - (a[2] * b[1]);
		result[1] = (a[2] * b[0]) - (a[0] * b[2]);
		result[2] = (a[0] * b[1]) - (a[1] * b[0]);
	}
	//----------------------------------
	//magnitude
	//----------------------------------
	public static double magnitude(double[] a, double[] b) {
		double x = a[0]-b[0], y = a[1]-b[1], z = a[2]-b[2];
		return Math.sqrt((x*x)+(y*y)+(z*z));
	}
	//----------------------------------
	//plane
	//----------------------------------
	public static void normal_plane(double[] normal, double[] p1, double[] p2, double[] p3){
		//normal = p1-p2 x p3-p2
		//k = normal * p1
		double[] tmp1 = new double[3], tmp2 = new double[3];
		Vector.sub(tmp1, p1, p2);
		Vector.sub(tmp2, p3, p2);
		Vector.cross_product(normal, tmp1, tmp2);
	}
}
